' SetTwainSource.vbs

Dim FSO, SH


Set FSO = CreateObject("Scripting.FileSystemObject")
Set SH  = CreateObject("WScript.Shell")


main


Sub main()
    Dim TwainDir

    TwainDir= GetEnv("windir") & "\twain_32" 

    Select Case WScript.Arguments.Count
    Case 0
        GetTwainSource TwainDir
    Case 1
        if WScript.Arguments(0) = "/?" then
            Usage TwainDir
        else
            SetTwainSource TwainDir, WScript.Arguments(0)
        end if
    Case Else
        Usage TwainDir
    End Select

End Sub


Sub GetTwainSource(pDir)
    Dim s
    s= RegGet("HKCU","Software\Microsoft\Windows NT\CurrentVersion\Twain","Default Source")
    s= mid(s,1+len(pDir),800)
    if mid(s,1,1)="\" then s=mid(s,2,800)
    WScript.echo "The current Twain driver is: " & s
End Sub


Sub SetTwainSource(pDir,pFn)

    If FSO.FileExists(pDir & "\" & pFn) Then
        RegSet "HKCU", "Software\Microsoft\Windows NT\CurrentVersion\Twain", "Default Source", pDir & "\" & pFn
    Else
        WScript.Echo "Driver: " & pFn & " doesn't exist."
        Usage pDir
    End If

End Sub


Sub Usage(pDir)
    Dim s

    s= "Usage: SetTwainSource [driver]"
    s= s & vblf & vblf & "driver :" & vbLF & FindFilesInTree(pDir,"","*.ds")
    WScript.echo s
    Wscript.Quit
End Sub


Public Function GetEnv(strEnv)
    GetEnv = SH.ExpandEnvironmentStrings("%" & strEnv & "%")
End Function


Public Function RegGet(pHive,pDir,pName)
    Dim s

    s= SH.RegRead(pHive & "\" & pDir & "\" & pName) 
    RegGet= s
End Function


Public Sub RegSet(pHive,pDir,pName,pValue)
    SH.RegWrite pHive& "\" & pDir & "\" & pName, pValue
End Sub


Function FindFilesInTree(pRoot,pDir,pMatch)
    Dim s, path
    Dim folder, files, f, dirs

    if right(pDir,1)<>"\" then pDir=pDir & "\"

    s= ""
    Set folder= FSO.GetFolder(pRoot & pDir)
    Set files  = folder.Files 
    For each f in files 
        if Right(f.name,3) = ".ds" then
            path = pDir & f.name
            if mid(path,1,1)="\" then path=mid(path,2,800)
            s= s & path & vbLF
        end if
    Next

    Set dirs = folder.SubFolders 
    For each f in dirs 
        s= s & FindFilesInTree(pRoot, pDir & f.name, pMatch)
    Next

    FindFilesInTree= s
End Function


sub SayErr(pPrelude)
    Msgbox pPrelude & vblf & "Error " & Err.Number & " - " & Err.Description 
end sub

